﻿/// <reference path="../../../../../Widgets/Wijmo/wijmenu/jquery.wijmo.wijmenu.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var c1;
(function (c1) {
    var $ = jQuery;

    var c1menu = (function (_super) {
        __extends(c1menu, _super);
        function c1menu() {
            _super.apply(this, arguments);
        }
        c1menu.prototype._create = function () {
            if (this.options.displayVisible === false) {
                return;
            }

            //this.element.wijAssignOptionsFromJsonInput(this);
            this.element.removeClass("ui-helper-hidden-accessible");
            _super.prototype._create.call(this);

            this._markPath(null);
            this._raiseClickEvent();
        };

        c1menu.prototype._init = function () {
            if (this.options.displayVisible === false) {
                return;
            }

            _super.prototype._init.call(this);
        };

        c1menu.prototype.destroy = function () {
            if (this.options.displayVisible === false) {
                return;
            }

            _super.prototype.destroy.call(this);
        };

        c1menu.prototype._setOption = function (key, value) {
            if (this.options.displayVisible === false) {
                return;
            }

            if (key === "width" || key === "height") {
                this.refresh();
            }

            _super.prototype._setOption.call(this, key, value);
        };

        c1menu.prototype._flyout = function () {
            var o = this.options, width = o.width, height = o.height, container;
            container = this.domObject.menucontainer;
            if (width !== "") {
                container.width(width);
            }
            if (height !== "") {
                container.height(height);
            }
            _super.prototype._flyout.call(this);
        };

        c1menu.prototype._drilldow = function () {
            var o = this.options, width = o.width, height = o.height, container;
            container = this.domObject.menucontainer;
            if (width !== "") {
                container.width(width);
            }
            if (height !== "") {
                container.height(height);
            }
            _super.prototype._drilldown.call(this);
        };

        c1menu.prototype._markPath = function (owner) {
            var _this = this;
            var path = "";
            if (owner) {
                path = owner.parent("li").data("path");
            } else {
                owner = this.element;
            }
            if (path !== "") {
                path += "-";
            }
            $(">li", owner).each(function (i, n) {
                $(n).data("path", path + i.toString());
                var childOwner = $(n).children("ul");
                if (childOwner.length > 0) {
                    _this._markPath(childOwner);
                }
            });
        };

        c1menu.prototype._raiseClickEvent = function () {
            var _postBackEventReference = this.options.postBackEventReference;
            if (_postBackEventReference) {
                $(".wijmo-wijmenu-link", this.element).each(function () {
                    var link = $(this), href, newRenference;
                    if (link.is("a")) {
                        href = link.attr("href");
                        if (href === undefined || href === "") {
                            return;
                        }
                        newRenference = _postBackEventReference.replace("_Args", "_ItemClick_" + link.parent("li").data("path"));
                        href = href.replace(_postBackEventReference, newRenference);
                        link.attr("href", href);
                    }
                });
            }
        };
        return c1menu;
    })(wijmo.menu.wijmenu);
    c1.c1menu = c1menu;

    c1menu.prototype.widgetEventPrefix = "c1menu";

    c1menu.prototype.options = $.extend(true, {}, $.wijmo.wijmenu.prototype.options, {
        postbackReference: null,
        ///	<summary>
        ///	A value indicating the width of the wijsplitter.
        /// Default: 400.
        /// Type: Int.
        ///	</summary>
        width: "",
        ///	<summary>
        ///	A value indicates the height of the wijsplitter.
        /// Default: 250.
        /// Type: Int.
        ///	</summary>
        height: ""
    });

    $.wijmo.registerWidget("c1menu", $.wijmo.wijmenu, c1menu.prototype);
})(c1 || (c1 = {}));
