﻿/// <reference path="../../../../../Widgets/Wijmo/wijtooltip/jquery.wijmo.wijtooltip.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery;

    var c1tooltip = (function (_super) {
        __extends(c1tooltip, _super);
        function c1tooltip() {
            _super.apply(this, arguments);
        }
        c1tooltip.prototype._create = function () {
            var self = this, o = self.options, element = self.element, id, label;

            if (o.displayVisible === false) {
                return;
            }

            if (o.enableCallBackMode && !o.useAjaxPostback && !o.ajaxCallback) {
                o.ajaxCallback = function () {
                    var ele = this, paramters = {
                        key: "AjaxCallback",
                        target: ""
                    }, target = "";

                    if (o.beforeAjaxCallback) {
                        target = o.beforeAjaxCallback.call(ele);
                    } else {
                        target = ele.attr("id");
                        if (target === "" || target === undefined) {
                            $.each($(o.targetSelector).toArray(), function (i, n) {
                                if (n === ele.get(0)) {
                                    target = i.toString();
                                    return false;
                                }
                            });
                        }
                    }
                    paramters.target = target;
                    if (!o.useAjaxPostback) {
                        self._doCallback(c1common.JSON.stringify(paramters), "ajaxCallback");
                    }
                };
            }
            _super.prototype._create.call(this);
            self.element.removeClass("ui-helper-hidden-accessible");

            // add checkbox and radio's label's tooltip
            if (element.is(":checkbox, :radio")) {
                id = element.attr("id");
                if (id !== "") {
                    label = $("[for='" + id + "']");
                    label.c1tooltip(self.options);
                }
            }

            self._tooltipCache._$tooltip.appendTo($("form:first"));
        };

        c1tooltip.prototype._init = function () {
            if (this.options.displayVisible === false) {
                return;
            }

            _super.prototype._init.call(this);
        };

        c1tooltip.prototype.destroy = function () {
            if (this.options.displayVisible === false) {
                return;
            }

            _super.prototype.destroy.call(this);
        };

        c1tooltip.prototype._setOption = function (key, value) {
            var o = this.options;

            if (o.displayVisible === false) {
                return;
            }

            _super.prototype._setOption.call(this, key, value);

            if (key === "content" && $.isFunction(value)) {
                if (o.innerStates && o.innerStates[key]) {
                    o.innerStates[key] = null;
                }
            }
        };

        c1tooltip.prototype._setText = function () {
            var o = this.options, container = $("#" + o.id), content = container.contents(), ele = this.element, tooltip = this._tooltipCache, hasTemplate = o.hasTemplate, title, remover, jqTitle = tooltip && tooltip._title;

            if (ele.is(":checkbox, :radio, label") && ele.attr("title") === "" && ele.parent().is("span")) {
                this._content = ele.parent().attr("title");
            }

            if (hasTemplate) {
                if (content.length > 0) {
                    tooltip._template = content;
                }

                if (tooltip._template) {
                    remover = $("<div></div>").appendTo("body").append(tooltip._container.contents());
                    tooltip._template.appendTo(tooltip._container);
                    remover.remove();
                }

                title = this._getContent(o.title);
                if (title !== "") {
                    jqTitle.html(title).show();
                } else {
                    jqTitle.hide();
                }
            } else {
                _super.prototype._setText.call(this);
            }
        };

        c1tooltip.prototype.show = function () {
            var ele = this.element, o = this.options, paramters = {
                key: "AjaxCallback",
                target: ""
            }, target = "";
            if (o.useAjaxPostback) {
                if (o.beforeAjaxCallback) {
                    target = o.beforeAjaxCallback.call(ele);
                } else {
                    target = ele.attr("id");
                    if (target === "" || target === undefined) {
                        $(o.targetSelector).each(function (i, n) {
                            if (n === ele.get(0)) {
                                target = i.toString();
                            }
                        });
                    }
                }
                paramters.target = target;
                __doPostBack(o.id + "_UpdatePanel1", c1common.JSON.stringify(paramters));
            }
            _super.prototype.show.call(this);
        };

        c1tooltip.prototype.encode = function () {
            var o = this.options;

            if (typeof (o.content) === "string") {
                o.content = escape(o.content);
            }
            if (typeof (o.title) === "string") {
                o.title = escape(o.title);
            }
        };

        c1tooltip.prototype._callbackComplete = function (returnValue, context) {
            if (returnValue === "") {
                return;
            }
            var obj = $.parseJSON(returnValue), ele = this.element;

            if (obj) {
                if (obj.title && obj.title !== "") {
                    this.options.title = obj.title;
                }
                if (obj.content && obj.content !== "") {
                    this.options.content = obj.content;
                }
            }
            ele.c1tooltip("option", "content", this.options.content);
            //end
        };

        c1tooltip.prototype._callbackError = function (arg) {
            alert(arg);
        };

        c1tooltip.prototype._doCallback = function (argument, context) {
            var self = this, o = self.options;
            self.element["wijSaveState"](self);
            c1common.updateWebFormsInternals(o.id, c1common.JSON.stringify(o));
            WebForm_DoCallback(o.uniqueID, argument, function (returnValue, context) {
                self._callbackComplete(returnValue, context);
            }, context, function (arg) {
                self._callbackError(arg);
            }, true);
        };
        return c1tooltip;
    })(wijmo.tooltip.wijtooltip);
    c1.c1tooltip = c1tooltip;

    c1tooltip.prototype.widgetEventPrefix = "c1tooltip";

    c1tooltip.prototype.options = $.extend(true, {}, $.wijmo.wijtooltip.prototype.options, {
        width: 200,
        height: 200,
        targetSelector: "",
        id: "",
        uniqueID: "",
        enableCallBackMode: false,
        beforeAjaxCallback: null,
        useAjaxPostback: false,
        innerStates: null,
        hasTemplate: false
    });

    $.wijmo.registerWidget("c1tooltip", $.wijmo.wijtooltip, c1tooltip.prototype);
})(c1 || (c1 = {}));
