/// <reference path="../../../../../Widgets/Wijmo/Base/jquery.wijmo.widget.ts"/>
/// <reference path="../../../../../Widgets/Wijmo/wijpager/jquery.wijmo.wijpager.ts"/>
/// <reference path="../../../../../Widgets/Wijmo/wijtextbox/jquery.wijmo.wijtextbox.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

// Module
var c1;
(function (c1) {
    // Class
    var $ = jQuery, command = "GetItems";
    ;

    var c1autocomplete = (function (_super) {
        __extends(c1autocomplete, _super);
        function c1autocomplete() {
            _super.apply(this, arguments);
        }
        c1autocomplete.prototype._setOption = function (key, value) {
            $.ui.autocomplete.prototype._setOption.apply(this, arguments);
        };

        c1autocomplete.prototype._create = function () {
            var self = this, o = self.options, el = self.element;
            el.removeClass("ui-helper-hidden-accessible").wijtextbox();

            if (o.items && o.items.length) {
                //				o.source = [];
                //				$.each(o.items, function (i, n) {
                //					o.source.push(n.label);
                //				});
                o.source = o.items;
            }

            $.ui.autocomplete.prototype._create.apply(self, arguments);

            $(self.menu.element).css("z-index", 100);

            self.element.bind("focus", function () {
                var parent, zIndex = 0;
                parent = self.element.parent();
                while (parent && !parent.is("body")) {
                    if (parent.css("z-Index") && zIndex < parseInt(parent.css("z-Index"))) {
                        zIndex = parseInt(parent.css("z-Index"));
                    }
                    parent = parent.parent();
                }
                if (parseInt($(self.menu.element).css("z-index")) <= zIndex) {
                    $(self.menu.element).css("z-index", zIndex + 10);
                }
            });

            self.menu.element.bind("menuselect", function (event, ui) {
                // update to jui 1.9.1 (API changed)
                // menuselected => menuselect,item.autocomplete => uiAutocompleteItem
                var item = ui.item.data("uiAutocompleteItem"), args = "itemSelected_" + item.value;
                el.val(item.value);
                if (o.autoPostBack) {
                    __doPostBack(o.uniqueID, args);
                }
            });
        };

        c1autocomplete.prototype._initSource = function () {
            var self = this, o = self.options;
            if (o.loadOnDemand) {
                self.source = function (request, response) {
                    self._doCallBack(request, response);
                };
            } else {
                $.ui.autocomplete.prototype._initSource.apply(this, arguments);
            }
        };

        c1autocomplete.prototype._doCallBack = function (request, response) {
            var self = this, o = self.options, id = o.uniqueID, requestData = { CommandName: undefined, CommandData: undefined }, arg, successCallBack = function (returnValue, context) {
                var value = returnValue, items;
                items = $.parseJSON(value);
                if ($.isArray(items)) {
                    response(items);
                } else {
                    alert(items.toString());
                }
            }, errorCallBack = function (error) {
                alert(error);
            };

            requestData.CommandName = command;
            requestData.CommandData = request;
            arg = c1common.JSON.stringify(requestData);

            WebForm_DoCallback(id, arg, successCallBack, command, errorCallBack, true);
        };

        c1autocomplete.prototype.saveAutoCompleteState = function () {
            var o = this.options, id = this.element.attr("id");

            //o.text = this.element.val();
            c1common.updateJsonHiddenField(id, c1common.JSON.stringify(o));
        };
        return c1autocomplete;
    })(wijmo.JQueryUIWidget);
    c1.c1autocomplete = c1autocomplete;

    c1autocomplete.prototype.options = $.extend(true, {}, $.ui.autocomplete.prototype.options, {
        source: []
    });

    $.wijmo.registerWidget("c1autocomplete", $.ui.autocomplete, c1autocomplete.prototype);
})(c1 || (c1 = {}));
