﻿/// <reference path="../../../../../Widgets/Wijmo/wijbubblechart/jquery.wijmo.wijbubblechart.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var C1;
(function (C1) {
    var c1bubblechart = (function (_super) {
        __extends(c1bubblechart, _super);
        function c1bubblechart() {
            _super.apply(this, arguments);
        }
        c1bubblechart.prototype._create = function () {
            window["c1chart"].initChartExport();
            var self = this, o = self.options, content = o.hint.content, isContentFunc;

            self.hintContent = content;
            if (o.hint && o.hint.enable) {
                isContentFunc = $.isFunction(content);
                o.hint.content = function () {
                    return window["c1chart"].handleHintContents(content, this, self, function (data) {
                        var hintContents = data.hintContents, index = data.index;
                        if (hintContents && hintContents.length && index < hintContents.length) {
                            return self._fotmatTooltip(hintContents[index]);
                        }
                        return null;
                    });
                };
            }
            self.element.removeClass("ui-helper-hidden-accessible");
            _super.prototype._create.call(this);
        };

        c1bubblechart.prototype._hasAxes = function () {
            if (this.widgetName === "c1piechart") {
                return false;
            }
            return true;
        };

        c1bubblechart.prototype.adjustOptions = function () {
            var self = this, o = self.options, axis = o.axis;
            o.hint.content = self.hintContent;
            if (axis && axis.x) {
                if (axis.x.autoMin) {
                    axis.x.min = null;
                }
                if (axis.x.autoMax) {
                    axis.x.max = null;
                }
            }
            if (axis && axis.y) {
                if ($.isArray(axis.y)) {
                    $.each(axis.y, function (i, yaxis) {
                        if (yaxis.autoMin) {
                            yaxis.min = null;
                        }
                        if (yaxis.autoMax) {
                            yaxis.max = null;
                        }
                    });
                } else {
                    if (axis.y.autoMin) {
                        axis.y.min = null;
                    }
                    if (axis.y.autoMax) {
                        axis.y.max = null;
                    }
                }
            }
        };
        return c1bubblechart;
    })(wijmo.chart.wijbubblechart);

    c1bubblechart.prototype.widgetEventPrefix = "c1bubblechart";
    $.wijmo.registerWidget("c1bubblechart", c1bubblechart.prototype);
})(C1 || (C1 = {}));
