/// <reference path="../../../../../Widgets/Wijmo/wijsplitter/jquery.wijmo.wijsplitter.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var c1;
(function (c1) {
    var $ = jQuery, c1splitterCss = "__c1splitter";

    var c1splitter = (function (_super) {
        __extends(c1splitter, _super);
        function c1splitter() {
            _super.apply(this, arguments);
        }
        c1splitter.prototype._setOption = function (key, value) {
            if (key === "width" || key === "height") {
                this.refresh(true, false);
            }

            $.wijmo.wijsplitter.prototype._setOption.apply(this, arguments);
        };

        c1splitter.prototype._updateDisabledDiv = function (ele, hidden) {
            if (ele == null) {
                return;
            }
            if (hidden) {
                ele.hide();
            } else {
                ele.show();
            }
        };

        c1splitter.prototype._createDisabledDiv = function (outerEle) {
            var disabledDiv = _super.prototype._createDisabledDiv.call(this, outerEle);
            this._updateDisabledDiv(disabledDiv, this.options.displayVisible === false);
            return disabledDiv;
        };

        c1splitter.prototype._create = function () {
            var self = this, element = self.element, parent = self.element.parents("." + c1splitterCss + ":first");

            //Remove the temp css label which is set at server side.
            element.removeClass(c1splitterCss);
            element.removeClass("ui-helper-hidden-accessible");

            if (self.options.fullSplit) {
                if (parent && parent.length > 0) {
                    parent.one("c1splitterload", function (e, data) {
                        if (data.element.attr("id") !== element.attr("id")) {
                            $.wijmo.wijsplitter.prototype._create.apply(self, arguments);
                        }
                    });

                    return;
                }
            }

            $.wijmo.wijsplitter.prototype._create.apply(self, arguments);
        };
        return c1splitter;
    })(wijmo.splitter.wijsplitter);
    c1.c1splitter = c1splitter;

    c1splitter.prototype.widgetEventPrefix = "c1splitter";

    c1splitter.prototype.options = $.extend(true, {}, $.wijmo.wijsplitter.prototype.options, {
        /// <summary>
        /// A value indicating the width of the wijsplitter.
        /// Default: 400.
        /// Type: Int.
        /// </summary>
        width: 400,
        /// <summary>
        /// A value indicates the height of the wijsplitter.
        /// Default: 250.
        /// Type: Int.
        /// </summary>
        height: 250
    });

    $.wijmo.registerWidget("c1splitter", c1splitter.prototype);
})(c1 || (c1 = {}));
